hybrid algorithms {bnlearn} | R Documentation

## Hybrid structure learning algorithms

### Description

Learn the structure of a Bayesian network with Max-Min Hill Climbing (MMHC), Hybrid HPC (H2PC), and the more general 2-phase Restricted Maximization (RSMAX2) hybrid algorithms.

### Usage

    rsmax2(x, whitelist = NULL, blacklist = NULL, restrict = "si.hiton.pc",
      maximize = "hc", restrict.args = list(), maximize.args = list(), debug = FALSE)
    mmhc(x, whitelist = NULL, blacklist = NULL, restrict.args = list(),
      maximize.args = list(), debug = FALSE)
    h2pc(x, whitelist = NULL, blacklist = NULL, restrict.args = list(),
      maximize.args = list(), debug = FALSE)

### Arguments

`x` | a data frame containing the variables in the model.
`whitelist` | a data frame with two columns (optionally labeled "from" and "to"), containing a set of arcs to be included in the graph.
`blacklist` | a data frame with two columns (optionally labeled "from" and "to"), containing a set of arcs not to be included in the graph.
`restrict` | a character string, the constraint-based or local search algorithm to be used in the “restrict” phase. See `structure learning` and the documentation of each algorithm for details.
`maximize` | a character string, the score-based algorithm to be used in the “maximize” phase. Possible values are `hc` and `tabu`. See `structure learning` for details.
`restrict.args` | a list of arguments to be passed to the algorithm specified by `restrict`, such as `test` or `alpha`.
`maximize.args` | a list of arguments to be passed to the algorithm specified by `maximize`, such as `restart` for hill-climbing or `tabu` for tabu search.
`debug` | a boolean value. If `TRUE` a lot of debugging output is printed; otherwise the function is completely silent.

### Value

An object of class `bn`. See `bn-class` for details.

### Note

`mmhc()` is simply `rsmax2()` with `restrict` set to `mmpc` and `maximize` set to `hc`. Similarly, `h2pc` is simply `rsmax2()` with `restrict` set to `hpc`and `maximize` set to `hc`.

See `structure learning` for a complete list of structure learning algorithms with the respective references.

### Author(s)

Marco Scutari

### See Also

local discovery algorithms, score-based algorithms, constraint-based algorithms.

[Package bnlearn version 4.7.1 Index]